import java.util.*;
import java.io.*;

abstract class trash {
  double Weight = 0F;
  trash() {}
  trash(double Wt) { Weight = Wt; }
  static Vector Prototypes = new Vector();
  static void AddPrototype(trash t) {
    Prototypes.addElement(t);
  }
  abstract double value();
  double weight() { return Weight; }
  static trash Factory(info i) {
    Enumeration e = Prototypes.elements();
    while(e.hasMoreElements()) {
      trash t = (trash)e.nextElement();
      // Somehow determine the new type
      // to create, and tClone one:
      if (i.id.equals(t.getClass().getName()))
        return t.tClone(i);
    }
    System.err.println("Prototype not found!");
    // "Default" to first one in the list:
    return
      ((trash)Prototypes.firstElement())
       .tClone(i);
  }
  abstract trash tClone(info i);
  abstract void Accept(Visitor v);
}

class info {
  String id;
  static final int maxnum = 3;
  double data;
  info(String name, double Data) {
    id = name;
    data = Data;
  }
}

abstract class Visitor {
  protected Visitor() {}
  abstract void VisitAluminum(aluminum a);
  abstract void VisitPaper(paper p);
  abstract void VisitGlass(glass g);
  abstract void VisitCardboard(Cardboard g);
}

class aluminum extends trash {
  private static double val = 1.67F;
  private aluminum() { AddPrototype(this); }
  private static aluminum _aluminum
    = new aluminum();
  protected aluminum(double Wt) { super(Wt); }
  double value() { return val; }
  static void value(double newval) {
    val = newval;
  }
  trash tClone(info i) {
    return new aluminum(i.data);
  }
  void Accept(Visitor v) {
    v.VisitAluminum(this);
  }
}

class paper extends trash {
  private static double val = 0.10F;
  private paper() { AddPrototype(this); }
  private static paper _paper = new paper();
  protected paper(double Wt) { super(Wt); }
  double value() { return val; }
  static void value(double newval) {
    val = newval;
  }
  trash tClone(info i) {
    return new paper(i.data);
  }
  void Accept(Visitor v) {
    v.VisitPaper(this);
  }
}

class glass extends trash {
  private static double val = 0.23F;
  private glass() { AddPrototype(this); }
  private static glass _glass = new glass();
  protected glass(double Wt) { super(Wt); }
  double value() { return val; }
  static void value(double newval) {
    val = newval;
  }
  trash tClone(info i) {
    return new glass(i.data);
  }
  void Accept(Visitor v) {
    v.VisitGlass(this);
  }
}

class Cardboard extends trash {
  private static double val = 0.23F;
  private Cardboard() { AddPrototype(this); }
  private static Cardboard _Cardboard = new Cardboard();
  protected Cardboard(double Wt) { super(Wt); }
  double value() { return val; }
  static void value(double newval) {
    val = newval;
  }
  trash tClone(info i) {
    return new Cardboard(i.data);
  }
  void Accept(Visitor v) {
    v.VisitCardboard(this);
  }
}

// Specific group of algorithms packaged
// in each subclass of Visitor:
class PriceVisitor extends Visitor {
  private double AlSum; // aluminum
  private double PSum; // paper
  private double GSum; // glass
  private double CSum; // cardboard
  void VisitAluminum(aluminum Al) {
    double v = Al.weight() * Al.value();
    System.out.println("value of aluminum= "+v);
    AlSum += v;
  }
  void VisitPaper(paper P) {
    double v = P.weight() * P.value();
    System.out.println("value of paper= " + v);
    PSum += v;
  }
  void VisitGlass(glass G) {
    double v = G.weight() * G.value();
    System.out.println("value of glass= " + v);
    GSum += v;
  }
  void VisitCardboard(Cardboard C) {
    double v = C.weight() * C.value();
    System.out.println("value of Cardboard= " + v);
    CSum += v;
  }
  void Total() {
    System.out.println(
      "Total Aluminum: $" + AlSum + "\n" +
      "Total Paper: $" + PSum + "\n" +
      "Total Glass: $" + GSum + "\n" +
      "Total Cardboard: $" + CSum
    );
  }
}

class WeightVisitor extends Visitor {
  private double AlSum; // aluminum
  private double PSum; // paper
  private double GSum; // glass
  private double CSum; // cardboard
  void VisitAluminum(aluminum Al) {
    AlSum += Al.weight();
    System.out.println("weight of aluminum = "
        + Al.weight());
  }
  void VisitPaper(paper P) {
    PSum += P.weight();
    System.out.println("weight of paper = "
        + P.weight());
  }
  void VisitGlass(glass G) {
    GSum += G.weight();
    System.out.println("weight of glass = "
        + G.weight());
  }
  void VisitCardboard(Cardboard C) {
    CSum += C.weight();
    System.out.println("weight of Cardboard = "
        + C.weight());
  }
  void Total() {
    System.out.println("Total weight Aluminum:"
        + AlSum);
    System.out.println("Total weight Paper:"
        + PSum);
    System.out.println("Total weight Glass:"
        + GSum);
    System.out.println("Total weight Cardboard:"
        + CSum);
  }
}

public class ch13ex2 {
  public static void main(String args[]) {
    // Force initialization of statics: (argh!)
    new aluminum(1); new paper(1); new glass(1);
    Vector bin = new Vector();
    // Fill up the trash bin:
    try {
      DataInputStream data =
        new DataInputStream(
          new BufferedInputStream(
            new FileInputStream("trash.dat")));
      String buf;
      while((buf = data.readLine())!= null) {
        String type =
          buf.substring(0, buf.indexOf(':')).trim();
        double weight = Double.valueOf(
          buf.substring(buf.indexOf(':') + 1)
          .trim()).doubleValue();
        bin.addElement(
          trash.Factory(
            new info(type, weight)
        ));
      }
      data.close();
    } catch(IOException e) {
      e.printStackTrace();
    }

    // You could even iterate through
    // a list of visitors!
    PriceVisitor PV = new PriceVisitor();
    WeightVisitor WV = new WeightVisitor();
    Enumeration it = bin.elements();
    while(it.hasMoreElements()) {
      trash t = (trash)it.nextElement();
      t.Accept(PV);
      t.Accept(WV);
    }
    PV.Total();
    WV.Total();
  }
}
